import CustomerParticleSystem from "./CustomerParticleSystem";
import PlayerComponent from "./PlayerComponent";

const {ccclass, property} = cc._decorator;

@ccclass
export default class GameComponent extends cc.Component {

    @property(cc.Node)
    player:cc.Node=null;

    @property(cc.Sprite)
    star:cc.Sprite=null;

    @property(cc.Node)
    bg:cc.Node =null;

    @property(cc.Node)
    bottom:cc.Node = null;

    onLoad(){
        //cc.director.setDisplayStats(false);
        this.bg.on(cc.Node.EventType.TOUCH_START,this.onBgTouch,this);
    }

    onEnable() {
        console.log("+++++++++onEnable++++++++");
        cc.director.getCollisionManager().enabled = true;
    }
    onDisable() {
        console.log("+++++++++onDisable++++++++");
        cc.director.getCollisionManager().enabled = false;
    }


    onBgTouch(){
        let playerComponent = <PlayerComponent>this.player.getComponent("PlayerComponent");
        playerComponent.moveUp();
    }

}
