
const { ccclass, property } = cc._decorator;
@ccclass
export default class MainComponent extends cc.Component {

    @property(cc.Node)
    player: cc.Node = null;
    private jumpHeight: number = 80;
    private jumpAction: cc.Action;
    private rigidBody: cc.RigidBody;
    onLoad() {
        cc.director.getCollisionManager().enabled = true;
        cc.director.getPhysicsManager().enabled = true;
        this.rigidBody = this.player.getComponent(cc.RigidBody);
    }

    moveUp() {
        this.disablePhysics();
        if (null != this.jumpAction) {
            this.player.stopAction(this.jumpAction);
        }
        let y = this.player.y;
        var actionOne = cc.jumpBy(0.3, cc.v2(0, this.jumpHeight), 20, 1);
        var actionTwo = cc.callFunc(this.moveDone, this);
        var action = cc.sequence(actionOne, actionTwo);
        this.jumpAction = this.player.runAction(action);

    }

    moveDone() {
        this.enablePhysics();
    }

    enableCollider() {
        cc.director.getCollisionManager().enabled = true;
    }

    enablePhysics() {
        this.rigidBody.awake = true;
    }

    disablePhysics() {
        this.rigidBody.awake = false;
    }

    onCollisionEnter(selft: cc.BoxCollider, other: cc.CircleCollider) {
        //TODO
        if (selft.name == "hand<BoxCollider>" && selft.offset.y == 190) {
            this.disablePhysics();
        }else if (selft.name == "bottom<BoxCollider>" && selft.offset.y == 0){
            this.disablePhysics();
        }
        let posi = selft.node.convertToWorldSpaceAR(selft.node.getPosition());
        console.log(selft.name,":",other.name,"    selft.offset.y:",selft.offset.y , " wordposi:",posi);

    }

    updateQuadWithParticle(particle: any, newPosition: any) {
        console.log("+++++++++updateQuadWithParticle++++++++++++");
    }

}