
import { HashMap } from '../util/HashMap';
export class ImageService {
    static map: HashMap<string, Object> = new HashMap<string, Object>();

    static loadResDir(dir: string) {
        let that = this;
        cc.loader.loadResDir(dir, cc.SpriteFrame, function (err, spriteFrames) {
            if (null != err) {
                return;
            }
            for (let index in spriteFrames) {
                let sprite: cc.SpriteFrame = spriteFrames[index];
                that.map.put(sprite.name, sprite);
            }
        });
    }

    static loadAtlas(dir: string) {
        let that = this;
        cc.loader.loadResDir(dir,cc.SpriteAtlas, function (err, assets) {
            if (null != err) {
                return;
            }

            for (let index in assets) {
                let atlas = <cc.SpriteAtlas>assets[index];
                let atlasName: string = atlas.name;
                atlasName = atlasName.substr(0, atlasName.lastIndexOf("."));
                let spriteFrames = atlas.getSpriteFrames();
                for (let index in spriteFrames) {
                    let sprite: cc.SpriteFrame = spriteFrames[index];
                    let spriteName = atlasName + "_" + sprite.name;
                    that.map.put(spriteName, sprite);
                }
            }

        });
    }

    static get<T>(key: string): T {
        return <T>this.map.get(key)
    }

}