export class PropRandomUtil {

    static randomOnePropWithTimes(start:Date,end:Date,prop:Prop):Prop{
        let props =new Array();
        props.push(prop);

        return this.randomPropWithTimes(start,end,props);
    }

    static randomPropWithTimes(start:Date,end:Date,props:Array<Prop>):Prop{
        let now = new Date().getTime();
        let startTime = start.getTime();
        let endTime = end.getTime();
        let award = this.randomProp(props);
        if (award == null){
            return null ;
        }

        let total =  award.total;
        let balance = award.balance;
        let dateTime = (endTime-startTime)/total;

        let updateTime = award.updateTime;
        let lastUpdateTime = 0;
        if (null != updateTime){
            lastUpdateTime = updateTime.getTime();
        }
        let random = Math.round(Math.random()*lastUpdateTime);

        let releaseTime = startTime+(total-balance)*dateTime+random%dateTime;

        if (now < releaseTime){
            return null;
        }
        award.setUpdateTime(new Date(releaseTime));
        award.decr();

        return award;


    }
    static randomProp(awards:Array<Prop>):Prop{
        let weight =0 ;
        for(let award of awards){
            weight+= award.balance;
        }

        if (weight == 0){
            return null;
        }

        let num:number = Math.round(Math.random()*weight);
        for(let award of awards){
            num -= award.balance;
            if (num <0){
                return award;
            }
        }

        return null;

    }

}


export class Prop {
    name: string;
    total: number = 0;
    balance: number = 0;
    updateTime;
    constructor(name:string,total:number){
        this.name = name;
        this.total = total;
        this.balance = total;
    }
    public decr() {
        this.balance--;
    }

    setUpdateTime(updateTime:Date){
        this.updateTime = updateTime;
    }
}