"use strict";
cc._RF.push(module, '4b6c7jTwdhKLrvJRdoXAhuB', 'CameraComponent');
// Script/component/CameraComponent.ts

Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var CameraComponent = /** @class */ (function (_super) {
    __extends(CameraComponent, _super);
    function CameraComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.camera = null;
        _this.target = null;
        _this.background = null;
        _this.followX = 0;
        _this.followY = 200;
        _this.centerAtStart = false;
        _this.smoothFollow = true;
        _this.startFollow = false;
        _this.minFollowDist = 200;
        _this.followRatio = 0.1;
        _this.upHeightRatio = 2;
        return _this;
    }
    CameraComponent.prototype.onEnable = function () {
        console.log("+++++++++onEnable++++++++");
        cc.director.getCollisionManager().enabled = true;
    };
    CameraComponent.prototype.onDisable = function () {
        console.log("+++++++++onDisable++++++++");
        cc.director.getCollisionManager().enabled = false;
    };
    CameraComponent.prototype.onLoad = function () {
        console.log("+++++++this.camera.targets:", this.camera);
        this.visibleSize = cc.view.getVisibleSize();
        this.maxUpHeight = this.visibleSize.height / this.upHeightRatio;
    };
    CameraComponent.prototype.update = function (dt) {
        var targetPos = this.target.parent.convertToWorldSpaceAR(this.target.position);
        if (targetPos.y > this.maxUpHeight && Math.abs(this.target.y - this.node.y) >= this.followY && this.node.y >= 0) {
            //console.log("++++++++++++targetPos.y:", targetPos.y, "  this.node.y:", this.node.y);
            this.startFollow = true;
        }
        if (this.startFollow) {
            var cameraPos = this.node.position;
            //console.log("++++++++++++targetPos.y:", targetPos.y, "  cameraPos.y:", cameraPos.y);
            var cameraNewPos = cameraPos.lerp(this.target.position, this.followRatio);
            if (cameraNewPos.y <= 0) {
                return;
            }
            if (null != this.latePosition && this.latePosition.y > cameraNewPos.y) {
                return;
            }
            this.node.position = cameraNewPos;
            this.latePosition = cameraNewPos;
            var distance = Math.abs(this.node.position.sub(targetPos).mag());
            if (distance <= this.minFollowDist) {
                this.startFollow = false;
            }
        }
    };
    __decorate([
        property(cc.Camera)
    ], CameraComponent.prototype, "camera", void 0);
    __decorate([
        property(cc.Node)
    ], CameraComponent.prototype, "target", void 0);
    __decorate([
        property(cc.Node)
    ], CameraComponent.prototype, "background", void 0);
    CameraComponent = __decorate([
        ccclass
    ], CameraComponent);
    return CameraComponent;
}(cc.Component));
exports.default = CameraComponent;

cc._RF.pop();