(function() {"use strict";var __module = CC_EDITOR ? module : {exports:{}};var __filename = 'preview-scripts/assets/Script/component/MainComponent.js';var __require = CC_EDITOR ? function (request) {return cc.require(request, require);} : function (request) {return cc.require(request, __filename);};function __define (exports, require, module) {"use strict";
cc._RF.push(module, 'b1ae9ZW/dVGermZ5FIMkYB0', 'MainComponent', __filename);
// Script/component/MainComponent.ts

Object.defineProperty(exports, "__esModule", { value: true });
var ImageService_1 = require("../service/ImageService");
var AudioService_1 = require("../service/AudioService");
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var MainComponent = /** @class */ (function (_super) {
    __extends(MainComponent, _super);
    function MainComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.gameVoiceBtn = null;
        _this.gameMusicBtn = null;
        _this.gameStartBtn = null;
        return _this;
    }
    MainComponent.prototype.onLoad = function () {
        this.gameVoiceBtn.node.on(cc.Node.EventType.TOUCH_START, this.onGameVoice, this);
        this.gameMusicBtn.node.on(cc.Node.EventType.TOUCH_START, this.onGameMusic, this);
        this.gameStartBtn.node.on(cc.Node.EventType.TOUCH_START, this.onStart, this);
        this.loadAtlas();
        this.loadAudios();
        this.playBgMusic();
        this.onBtnAnimal();
        this.loadScence();
    };
    MainComponent.prototype.loadScence = function () {
        cc.director.preloadScene("Main");
        cc.director.preloadScene("Game");
    };
    MainComponent.prototype.loadAtlas = function () {
        ImageService_1.ImageService.loadAtlas("images/atlas");
    };
    MainComponent.prototype.loadAudios = function () {
        AudioService_1.AudioService.loadResDir("audios", this.playBgMusic.bind(this));
    };
    MainComponent.prototype.onStart = function () {
        cc.director.loadScene("Game");
    };
    MainComponent.prototype.onGameVoice = function (event) {
        var frameName = this.gameVoiceBtn.spriteFrame.name;
        if (frameName == "voice_open") {
            var spriteFrame = ImageService_1.ImageService.get("checkbox_voice_close");
            this.gameVoiceBtn.spriteFrame = spriteFrame;
        }
        else {
            var spriteFrame = ImageService_1.ImageService.get("checkbox_voice_open");
            this.gameVoiceBtn.spriteFrame = spriteFrame;
        }
    };
    MainComponent.prototype.onGameMusic = function (event) {
        var frameName = this.gameMusicBtn.spriteFrame.name;
        if (frameName == "music_open") {
            var spriteFrame = ImageService_1.ImageService.get("checkbox_music_close");
            this.gameMusicBtn.spriteFrame = spriteFrame;
            this.stopBgMusic();
        }
        else {
            var spriteFrame = ImageService_1.ImageService.get("checkbox_music_open");
            this.gameMusicBtn.spriteFrame = spriteFrame;
            this.playBgMusic();
        }
    };
    MainComponent.prototype.newActionInterval = function () {
        var actionOne = cc.scaleTo(0.1, 1.2, 1.2);
        var actionTwo = cc.scaleTo(0.1, 1, 1);
        return cc.sequence(actionOne, actionTwo);
    };
    MainComponent.prototype.playBgMusic = function () {
        var clip = AudioService_1.AudioService.get("bg");
        if (null != clip) {
            this.bgMusicId = cc.audioEngine.play(clip, false, 0.5);
        }
    };
    MainComponent.prototype.stopBgMusic = function () {
        cc.audioEngine.stop(this.bgMusicId);
    };
    MainComponent.prototype.onBtnAnimal = function () {
        var gameMusicAction = this.newActionInterval();
        this.gameMusicBtn.node.runAction(gameMusicAction);
        var gameVoiceAction = this.newActionInterval();
        this.gameVoiceBtn.node.runAction(gameVoiceAction);
        this.onStartAnimal();
    };
    MainComponent.prototype.onStartAnimal = function () {
        var actionOne = cc.scaleTo(1, 0.8, 0.8);
        var actionTwo = cc.scaleTo(1, 1, 1);
        var seqAction = cc.sequence(actionOne, actionTwo);
        var repeatAction = cc.repeatForever(seqAction);
        this.gameStartBtn.node.runAction(repeatAction);
    };
    __decorate([
        property(cc.Sprite)
    ], MainComponent.prototype, "gameVoiceBtn", void 0);
    __decorate([
        property(cc.Sprite)
    ], MainComponent.prototype, "gameMusicBtn", void 0);
    __decorate([
        property(cc.Sprite)
    ], MainComponent.prototype, "gameStartBtn", void 0);
    MainComponent = __decorate([
        ccclass
    ], MainComponent);
    return MainComponent;
}(cc.Component));
exports.default = MainComponent;

cc._RF.pop();
        }
        if (CC_EDITOR) {
            __define(__module.exports, __require, __module);
        }
        else {
            cc.registerModuleFunc(__filename, function () {
                __define(__module.exports, __require, __module);
            });
        }
        })();
        //# sourceMappingURL=MainComponent.js.map
        