(function() {"use strict";var __module = CC_EDITOR ? module : {exports:{}};var __filename = 'preview-scripts/assets/Script/util/Http.js';var __require = CC_EDITOR ? function (request) {return cc.require(request, require);} : function (request) {return cc.require(request, __filename);};function __define (exports, require, module) {"use strict";
cc._RF.push(module, '0bd78quv61FsZKQX23Wizay', 'Http', __filename);
// Script/util/Http.ts

Object.defineProperty(exports, "__esModule", { value: true });
var ProtocolResponse_1 = require("../proto/response/ProtocolResponse");
var Http = /** @class */ (function () {
    function Http() {
    }
    Http.post = function (url, params, options) {
        return __awaiter(this, void 0, Promise, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.service(url, "post", params, options)];
            });
        });
    };
    Http.get = function (url, params, options) {
        return __awaiter(this, void 0, Promise, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.service(url, "get", params, options)];
            });
        });
    };
    Http.service = function (url, method, params, options) {
        options = this.settings(url, params, options);
        options.method = method;
        var that = this;
        console.log("+++++++http url:", url, " method:", method, " request:" + JSON.stringify(options.data));
        var promise = new Promise(function (resolve) {
            options.complete = function complete(res) {
                console.log("+++++++http url:", url, " method:", method, " response:" + JSON.stringify(res.data));
                var response = null;
                if (res.statusCode === 200) {
                    response = that.toSuccessResponse(res.data);
                }
                else {
                    response = that.toFailResponse();
                }
                resolve(response);
            };
            wx.request(options);
        });
        return promise;
    };
    Http.toSuccessResponse = function (data) {
        var that = this;
        var response = Object.assign(new ProtocolResponse_1.ProtocolResponse(), data);
        return response;
    };
    Http.toFailResponse = function () {
        var response = new ProtocolResponse_1.ProtocolResponse();
        response.code = -1;
        response.msg = "";
        response.result = "";
        return response;
    };
    Http.settings = function (url, params, options) {
        var tmpSetting = {};
        if (url) {
            tmpSetting.url = url;
        }
        if (options) {
            for (var key in options) {
                tmpSetting[key] = options[key];
            }
        }
        if (params) {
            tmpSetting.data = params;
        }
        tmpSetting.header = {
            'content-type': 'application/x-www-form-urlencoded'
        };
        return tmpSetting;
    };
    Http.buildParams = function (data) {
        var _type = typeof (data);
        if (!data || _type == 'string') {
            return data;
        }
        if (_type == 'object') {
            var params = '';
            for (var key in data) {
                params += key + '=' + data[key] + '&';
            }
            return params;
        }
        return data;
    };
    Http.checkNetwork = function (res) {
        if (res == null || undefined == res.statusCode || null == res.statusCode) {
            Mini.errorShowToast({ title: "网络加载失败" });
            return false;
        }
    };
    Http.openNetworkListen = function () {
        var that = this;
        //添加网络状态监听
        wx.onNetworkStatusChange(function (status) {
            that.connected = status.isConnected;
        });
    };
    Http.isConnected = function () {
        var that = this;
        console.log("network.isConnected:", that.connected);
        if (!that.connected) {
            Mini.errorShowToast({ title: "网络加载失败" });
            return false;
        }
        return true;
    };
    Http.connected = true;
    return Http;
}());
exports.Http = Http;

cc._RF.pop();
        }
        if (CC_EDITOR) {
            __define(__module.exports, __require, __module);
        }
        else {
            cc.registerModuleFunc(__filename, function () {
                __define(__module.exports, __require, __module);
            });
        }
        })();
        //# sourceMappingURL=Http.js.map
        